pipeline {
    agent any
    environment {
        MAVEN_HOME = tool 'Maven'
        JAVA_HOME = tool 'Java'
        NEXUS_URL = 'http://nexus-ynov-sandbox.asys-cloud.fr:80/repository/maven-releases/'
        NEXUS_USERNAME = 'jenkins'
        NEXUS_PASSWORD = 'hDkxFxBSwmQ3ANLBFt'
        GIT_BRANCH = 'add-pipeline-jar'
    }
    stages {
        stage('Récupération des sources') {
            steps {
                checkout scm
            }
        }
        stage('Compilation') {
            steps {
                sh "${MAVEN_HOME}/bin/mvn clean package"
            }
        }
        stage('Lint via Spotless') {
            steps {
                sh "${MAVEN_HOME}/bin/mvn spotless:check"
            }
        }
        stage('Lancement des tests') {
            steps {
                sh "${MAVEN_HOME}/bin/mvn test"
            }
        }
        stage('Push sur Nexus') {
            steps {
                withCredentials([usernamePassword(credentialsId: 'nexus-credentials', passwordVariable: 'NEXUS_PASSWORD', usernameVariable: 'NEXUS_USERNAME')]) {
                    sh "${MAVEN_HOME}/bin/mvn deploy -Dmaven.test.skip=true -DaltDeploymentRepository=nexus::default::${NEXUS_URL} -Dusername=${NEXUS_USERNAME} -Dpassword=${NEXUS_PASSWORD}"
                }
            }
        }
    }
    post {
        success {
            sh "git push origin ${GIT_BRANCH}"
        }
    }
}
  }
}
